diff --git a/pki/base/util/src/netscape/security/extensions/GenericASN1Extension.java b/pki/base/util/src/netscape/security/extensions/GenericASN1Extension.java
index 617ebacd845e85c6d14c22ba6b112eb3fd8b82d6..6e28b4a0ee3e691e18e97af21694fc7a5a4a2eba 100644
--- a/pki/base/util/src/netscape/security/extensions/GenericASN1Extension.java
+++ b/pki/base/util/src/netscape/security/extensions/GenericASN1Extension.java
@@ -34,7 +34,6 @@ import netscape.security.util.BigInt;
 import netscape.security.util.DerOutputStream;
 import netscape.security.util.DerValue;
 import netscape.security.util.ObjectIdentifier;
-
 import netscape.security.x509.CertAttrSet;
 import netscape.security.x509.Extension;
 import netscape.security.x509.OIDMap;
@@ -73,9 +72,9 @@ public class GenericASN1Extension extends Extension
      * Identifier for this attribute, to be used with the
      * get, set, delete methods of Certificate, x509 type.
      */
-    public static String NAME = null;
+    private String name;
     public static String OID = null;
-    public static Hashtable mConfig = null;
+    public static Hashtable<String, String> mConfig = null;
     public static String pattern = null;
     private int index = 0;
 
@@ -177,10 +176,11 @@ public class GenericASN1Extension extends Extension
      * 
      * @param the values to be set for the extension.
      */
-    public GenericASN1Extension(String name, String oid, String pattern, boolean critical, Hashtable config)
+    public GenericASN1Extension(String name, String oid, String pattern, boolean critical,
+            Hashtable<String, String> config)
             throws IOException, ParseException {
         ObjectIdentifier tmpid = new ObjectIdentifier(oid);
-        NAME = name;
+        this.name = name;
         OID = oid;
         mConfig = config;
         this.pattern = pattern;
@@ -202,17 +202,17 @@ public class GenericASN1Extension extends Extension
      * 
      * @param the values to be set for the extension.
      */
-    public GenericASN1Extension(Hashtable config)
+    public GenericASN1Extension(Hashtable<String, String> config)
             throws IOException, ParseException {
         mConfig = config;
         ObjectIdentifier tmpid = new ObjectIdentifier((String) mConfig.get(PROP_OID));
-        NAME = (String) mConfig.get(PROP_NAME);
+        name = (String) mConfig.get(PROP_NAME);
         OID = (String) mConfig.get(PROP_OID);
         pattern = (String) mConfig.get(PROP_PATTERN);
 
         try {
             if (OIDMap.getName(tmpid) == null)
-                OIDMap.addAttribute("GenericASN1Extension", OID, NAME);
+                OIDMap.addAttribute("GenericASN1Extension", OID, name);
         } catch (CertificateException e) {
         }
 
@@ -311,14 +311,14 @@ public class GenericASN1Extension extends Extension
      * Return the name of this attribute.
      */
     public String getName() {
-        return (NAME);
+        return name;
     }
 
     /**
      * Set the name of this attribute.
      */
     public void setName(String name) {
-        NAME = name;
+        this.name = name;
     }
 
     /**
@@ -339,7 +339,7 @@ public class GenericASN1Extension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement("octet");
 
diff --git a/pki/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java b/pki/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java
index a09e089c36ba1b03218a7f8e5fe9af903c5cec00..81b8cf5b5656d670517b260e0e375086f87944dc 100644
--- a/pki/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java
+++ b/pki/base/util/src/netscape/security/extensions/InhibitAnyPolicyExtension.java
@@ -131,7 +131,7 @@ public class InhibitAnyPolicyExtension
         return null;
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         return null;
     }
 
diff --git a/pki/base/util/src/netscape/security/extensions/KerberosName.java b/pki/base/util/src/netscape/security/extensions/KerberosName.java
index 269775d317d174bd6f50ca5d966b49ca82253c53..0a6a6e2133b7a116a5126030c380ba04ffd0ee1c 100644
--- a/pki/base/util/src/netscape/security/extensions/KerberosName.java
+++ b/pki/base/util/src/netscape/security/extensions/KerberosName.java
@@ -53,9 +53,9 @@ public class KerberosName {
 
     private String m_realm = null;
     private int m_name_type = 0;
-    private Vector m_name_strings = null;
+    private Vector<String> m_name_strings = null;
 
-    public KerberosName(String realm, int name_type, Vector name_strings) {
+    public KerberosName(String realm, int name_type, Vector<String> name_strings) {
         m_realm = realm;
         m_name_type = name_type;
         m_name_strings = name_strings;
@@ -119,7 +119,7 @@ public class KerberosName {
     }
 
     public static void main(String[] argv) {
-        Vector strings = new Vector();
+        Vector<String> strings = new Vector<String>();
         strings.addElement("name");
         KerberosName k = new KerberosName("realm", 0, strings);
 
diff --git a/pki/base/util/src/netscape/security/extensions/NSCertTypeExtension.java b/pki/base/util/src/netscape/security/extensions/NSCertTypeExtension.java
index 1415478bb1710d15bbc29bb40d59b3b0cb3b0697..04b3038e515aa1a6838e9db626015bfa27f0cf12 100644
--- a/pki/base/util/src/netscape/security/extensions/NSCertTypeExtension.java
+++ b/pki/base/util/src/netscape/security/extensions/NSCertTypeExtension.java
@@ -114,7 +114,7 @@ public class NSCertTypeExtension extends Extension implements CertAttrSet {
                 new MapEntry(OBJECT_SIGNING_CA, 7),
         };
 
-    private static Vector mAttributeNames = new Vector();
+    private static Vector<String> mAttributeNames = new Vector<String>();
 
     static {
         for (int i = 0; i < mMapData.length; ++i) {
@@ -361,7 +361,7 @@ public class NSCertTypeExtension extends Extension implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         return mAttributeNames.elements();
     }
 
diff --git a/pki/base/util/src/netscape/security/extensions/OCSPNoCheckExtension.java b/pki/base/util/src/netscape/security/extensions/OCSPNoCheckExtension.java
index 46abc3c1f8a663d4a349cdadef2d70fc9511a4a1..28da8085f787c8cc3b23e00b04e013f4a1bb8444 100644
--- a/pki/base/util/src/netscape/security/extensions/OCSPNoCheckExtension.java
+++ b/pki/base/util/src/netscape/security/extensions/OCSPNoCheckExtension.java
@@ -137,7 +137,7 @@ public class OCSPNoCheckExtension extends Extension implements CertAttrSet {
         return null;
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         // NOT USED
         return null;
     }
diff --git a/pki/base/util/src/netscape/security/extensions/PresenceServerExtension.java b/pki/base/util/src/netscape/security/extensions/PresenceServerExtension.java
index 1dafed19a83db57d23b592e93d9b1ffaf91486e1..a90abe7e354accaf442dca2987ec4b0fa8f4ed69 100644
--- a/pki/base/util/src/netscape/security/extensions/PresenceServerExtension.java
+++ b/pki/base/util/src/netscape/security/extensions/PresenceServerExtension.java
@@ -230,7 +230,7 @@ public class PresenceServerExtension extends Extension implements CertAttrSet {
         throw new IOException("Method not to be called directly.");
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         return null;
     }
 
diff --git a/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java b/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
index 2e9d7935dc1c33e41dca4073f75d3709d6f9461d..d78ad0344633c51c441f159dbc8a7cb86ff1202b 100644
--- a/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
+++ b/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
@@ -44,9 +44,6 @@ import netscape.security.x509.URIName;
  * @version $Revision$, $Date$
  */
 public class SubjectInfoAccessExtension extends Extension implements CertAttrSet {
-    /**
-     *
-     */
     private static final long serialVersionUID = 7237321566602583325L;
 
     public static final String NAME = "SubjectInfoAccessExtension";
@@ -62,7 +59,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
     public static final int OID[] = { 1, 3, 6, 1, 5, 5, 7, 1, 11 };
     public static final ObjectIdentifier ID = new ObjectIdentifier(OID);
 
-    private Vector mDesc = new Vector();
+    private Vector<AccessDescription> mDesc = new Vector<AccessDescription>();
 
     /**
      * Create the extension from the passed DER encoded value of the same.
@@ -118,7 +115,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         // NOT USED
         return null;
     }
@@ -141,7 +138,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
     }
 
     public AccessDescription getAccessDescription(int pos) {
-        return (AccessDescription) mDesc.elementAt(pos);
+        return mDesc.elementAt(pos);
     }
 
     /**
@@ -172,7 +169,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
 
         for (int i = 0; i < mDesc.size(); i++) {
             DerOutputStream tmp0 = new DerOutputStream();
-            AccessDescription ad = (AccessDescription) mDesc.elementAt(i);
+            AccessDescription ad = mDesc.elementAt(i);
 
             tmp0.putOID(ad.getMethod());
             ad.getLocation().encode(tmp0);
@@ -205,7 +202,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
         String s = super.toString() + "AuthInfoAccess [\n";
 
         for (int i = 0; i < mDesc.size(); i++) {
-            AccessDescription ad = (AccessDescription) mDesc.elementAt(i);
+            AccessDescription ad = mDesc.elementAt(i);
 
             s += "(" + i + ")";
             s += " ";
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java b/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
index 520b3e9691d046635c44bf7b5c092b638bf8c530..a649c395a972468f7e1eb2186e69987649a689c7 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
@@ -114,17 +114,18 @@ public class PKCS10Attribute implements DerEncoder, Serializable {
             }
         }
         byte[] val = inAttrValue.toByteArray();
-        Class[] params = { Object.class };
+        Class<?>[] params = { Object.class };
         try {
-            Class extClass = OIDMap.getClass(attributeId);
+            @SuppressWarnings("unchecked")
+            Class<CertAttrSet> extClass = (Class<CertAttrSet>) OIDMap.getClass(attributeId);
             if (extClass != null) {
-                Constructor cons = extClass.getConstructor(params);
+                Constructor<CertAttrSet> cons = (Constructor<CertAttrSet>) extClass.getConstructor(params);
                 Object value = Array.newInstance(byte.class, val.length);
                 for (int i = 0; i < val.length; i++) {
                     Array.setByte(value, i, val[i]);
                 }
                 Object[] passed = new Object[] { value };
-                attributeValue = (CertAttrSet) cons.newInstance(passed);
+                attributeValue = cons.newInstance(passed);
             } else {
                 // attribute classes are usable for PKCS10 attributes. 
                 // this is used where the attributes are not actual 
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java b/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
index ef0f6a4819b591524dd5d93777ff0269cd8dad0e..6a6fd7dc9a6cb39e75e845d2c8106c4c0e72c7af 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
@@ -100,7 +100,8 @@ public class PKCS9Attribute implements DerEncoder {
      * attributes to their OIDs. This table contains all name forms
      * that occur in PKCS9, in lower case.
      */
-    private static final Hashtable NAME_OID_TABLE = new Hashtable(28);
+    private static final Hashtable<String, ObjectIdentifier> NAME_OID_TABLE = new Hashtable<String, ObjectIdentifier>(
+            28);
 
     static { // static initializer for PCKS9_NAMES
         NAME_OID_TABLE.put("emailaddress", PKCS9_OIDS[1]);
@@ -124,7 +125,8 @@ public class PKCS9Attribute implements DerEncoder {
      * Hashtable mapping attribute OIDs defined in PKCS9 to the
      * corresponding attribute value type.
      */
-    private static final Hashtable OID_NAME_TABLE = new Hashtable(14);
+    private static final Hashtable<ObjectIdentifier, String> OID_NAME_TABLE = new Hashtable<ObjectIdentifier, String>(
+            14);
     static {
         OID_NAME_TABLE.put(PKCS9_OIDS[1], EMAIL_ADDRESS_STR);
         OID_NAME_TABLE.put(PKCS9_OIDS[2], UNSTRUCTURED_NAME_STR);
@@ -167,7 +169,7 @@ public class PKCS9Attribute implements DerEncoder {
             null, //PublicKey
             null, //SigningDescription
             { Byte.valueOf(DerValue.tag_Sequence) } //ExtensionRequest
-    };
+            };
 
     /**
      * Class types required for values for a given PKCS9
@@ -286,35 +288,25 @@ public class PKCS9Attribute implements DerEncoder {
      * 
      * </TABLE>
      */
-    private static final Class[] VALUE_CLASSES = new Class[15];
+    private static final Class<?>[] VALUE_CLASSES = new Class[15];
 
     static {
-        try {
-            Class str = Class.forName("[Ljava.lang.String;");
+        VALUE_CLASSES[0] = null; // not used
+        VALUE_CLASSES[1] = String[].class; // EMailAddress
+        VALUE_CLASSES[2] = String[].class; // UnstructuredName
+        VALUE_CLASSES[3] = ObjectIdentifier.class; // ContentType
+        VALUE_CLASSES[4] = byte[].class; // MessageDigest (byte[])
+        VALUE_CLASSES[5] = Date.class; // SigningTime
+        VALUE_CLASSES[6] = SignerInfo[].class; // Countersignature
+        VALUE_CLASSES[7] = String.class; // ChallengePassword
+        VALUE_CLASSES[8] = String[].class; // UnstructuredAddress
+        VALUE_CLASSES[9] = null; // ExtendedCertificateAttributes
 
-            VALUE_CLASSES[0] = null; // not used
-            VALUE_CLASSES[1] = str; // EMailAddress
-            VALUE_CLASSES[2] = str; // UnstructuredName
-            VALUE_CLASSES[3] = // ContentType
-            Class.forName("netscape.security.util.ObjectIdentifier");
-            VALUE_CLASSES[4] = Class.forName("[B"); // MessageDigest (byte[])
-            VALUE_CLASSES[5] = Class.forName("java.util.Date"); // SigningTime
-            VALUE_CLASSES[6] = // Countersignature
-            Class.forName("[Lnetscape.security.pkcs.SignerInfo;");
-            VALUE_CLASSES[7] = // ChallengePassword
-            Class.forName("java.lang.String");
-            VALUE_CLASSES[8] = str; // UnstructuredAddress
-            VALUE_CLASSES[9] = null; // ExtendedCertificateAttributes
-
-            VALUE_CLASSES[10] = null; // IssuerAndSerialNumber
-            VALUE_CLASSES[11] = null; // PasswordCheck
-            VALUE_CLASSES[12] = null; // PublicKey
-            VALUE_CLASSES[13] = null; // SigningDescription
-            VALUE_CLASSES[14] = // ExtensionRequest
-            Class.forName("netscape.security.x509.CertificateExtensions"); //xxxx
-        } catch (ClassNotFoundException e) {
-            throw new ExceptionInInitializerError(e.toString());
-        }
+        VALUE_CLASSES[10] = null; // IssuerAndSerialNumber
+        VALUE_CLASSES[11] = null; // PasswordCheck
+        VALUE_CLASSES[12] = null; // PublicKey
+        VALUE_CLASSES[13] = null; // SigningDescription
+        VALUE_CLASSES[14] = CertificateExtensions.class; // ExtensionRequest
     }
 
     /**
diff --git a/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java b/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java
index 4c5ab00d810657dfa06ab6bde6dfd56418e9ea02..9780983a5b651e63987ff53c85f2e963b4c6dca2 100644
--- a/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java
+++ b/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java
@@ -36,7 +36,7 @@ public class X509CertificateFactory extends CertificateFactorySpi {
         return new X509CertImpl(inStream);
     }
 
-    public Collection engineGenerateCertificates(InputStream inStream)
+    public Collection<Certificate> engineGenerateCertificates(InputStream inStream)
             throws CertificateException {
         return null;
     }
@@ -53,7 +53,7 @@ public class X509CertificateFactory extends CertificateFactorySpi {
         return crl;
     }
 
-    public Collection engineGenerateCRLs(InputStream inStream)
+    public Collection<CRL> engineGenerateCRLs(InputStream inStream)
             throws CRLException {
         return null;
     }
diff --git a/pki/base/util/src/netscape/security/util/CertPrettyPrint.java b/pki/base/util/src/netscape/security/util/CertPrettyPrint.java
index 86449c232c83fd794d5d98c6920e2581449c3ffc..3a8c65fd020d40b0c7007700cfa6e88650d92788 100644
--- a/pki/base/util/src/netscape/security/util/CertPrettyPrint.java
+++ b/pki/base/util/src/netscape/security/util/CertPrettyPrint.java
@@ -125,8 +125,8 @@ public class CertPrettyPrint {
                 SET certs = sd.getCertificates();
 
                 for (int i = 0; i < certs.size(); i++) {
-                    org.mozilla.jss.pkix.cert.Certificate cert = (org.mozilla.jss.pkix.cert.Certificate) certs
-                            .elementAt(i);
+                    org.mozilla.jss.pkix.cert.Certificate cert =
+                            (org.mozilla.jss.pkix.cert.Certificate) certs.elementAt(i);
                     X509CertImpl certImpl = null;
                     try {
                         certImpl = new X509CertImpl(
diff --git a/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java b/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java
index afb5d352a0ae60b09aa9cf9dc5fd4e99e801598c..edf1217ea7215007f69eae327b03fc25c0b604d1 100644
--- a/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java
+++ b/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java
@@ -26,7 +26,7 @@ import java.util.TimeZone;
 
 import netscape.security.x509.CRLExtensions;
 import netscape.security.x509.Extension;
-import netscape.security.x509.RevokedCertImpl;
+import netscape.security.x509.RevokedCertificate;
 import netscape.security.x509.X509CRLImpl;
 
 /**
@@ -174,15 +174,14 @@ public class CrlPrettyPrint {
                 }
                 sb.append("\n");
 
-                Set revokedCerts = mCRL.getRevokedCertificates();
+                Set<RevokedCertificate> revokedCerts = mCRL.getRevokedCertificates();
 
                 if (revokedCerts != null) {
-                    Iterator i = revokedCerts.iterator();
+                    Iterator<RevokedCertificate> i = revokedCerts.iterator();
                     long l = 1;
 
                     while ((i.hasNext()) && ((crlSize == 0) || (pageStart + pageSize > l))) {
-                        RevokedCertImpl revokedCert =
-                                (RevokedCertImpl) i.next();
+                        RevokedCertificate revokedCert = i.next();
 
                         if ((crlSize == 0) || ((pageStart <= l) && (pageStart + pageSize > l))) {
                             sb.append(pp.indent(16) + resource.getString(
diff --git a/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java b/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java
index 51ddf2321c4b59e9de95fd91a08a627e3d0659ef..90d0d094f8b47e1945eed9fcb004eeb37c074bbc 100644
--- a/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java
+++ b/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java
@@ -504,7 +504,7 @@ public class ExtPrettyPrint {
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(
                     PrettyPrintResources.TOKEN_EXTENDED_KEY_USAGE) + "\n");
             ExtendedKeyUsageExtension usage = (ExtendedKeyUsageExtension) mExt;
-            Enumeration e = usage.getOIDs();
+            Enumeration<ObjectIdentifier> e = usage.getOIDs();
 
             if (e != null) {
                 while (e.hasMoreElements()) {
@@ -589,8 +589,8 @@ public class ExtPrettyPrint {
 
         try {
             sb.append(pp.indent(mIndentSize) + mResource.getString(PrettyPrintResources.TOKEN_IDENTIFIER));
-            sb.append(mResource.getString(PrettyPrintResources.TOKEN_CERT_TYPE) + "- "
-                    + mExt.getExtensionId().toString() + "\n");
+            sb.append(mResource.getString(PrettyPrintResources.TOKEN_CERT_TYPE)
+                    + "- " + mExt.getExtensionId().toString() + "\n");
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(PrettyPrintResources.TOKEN_CRITICAL));
             if (mExt.isCritical()) {
                 sb.append(mResource.getString(PrettyPrintResources.TOKEN_YES) + "\n");
@@ -619,8 +619,8 @@ public class ExtPrettyPrint {
                 sb.append(pp.indent(mIndentSize + 8) + mResource.getString(NSCertTypeExtension.EMAIL_CA) + "\n");
             }
             if (((Boolean) type.get(NSCertTypeExtension.OBJECT_SIGNING_CA)).booleanValue()) {
-                sb.append(pp.indent(mIndentSize + 8) + mResource.getString(NSCertTypeExtension.OBJECT_SIGNING_CA)
-                        + "\n");
+                sb.append(pp.indent(mIndentSize + 8)
+                        + mResource.getString(NSCertTypeExtension.OBJECT_SIGNING_CA) + "\n");
             }
             return sb.toString();
         } catch (Exception e) {
@@ -637,8 +637,8 @@ public class ExtPrettyPrint {
 
         try {
             sb.append(pp.indent(mIndentSize) + mResource.getString(PrettyPrintResources.TOKEN_IDENTIFIER));
-            sb.append(mResource.getString(PrettyPrintResources.TOKEN_SKI) + "- " + mExt.getExtensionId().toString()
-                    + "\n");
+            sb.append(mResource.getString(PrettyPrintResources.TOKEN_SKI)
+                    + "- " + mExt.getExtensionId().toString() + "\n");
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(PrettyPrintResources.TOKEN_CRITICAL));
             if (mExt.isCritical()) {
                 sb.append(mResource.getString(PrettyPrintResources.TOKEN_YES) + "\n");
@@ -666,8 +666,8 @@ public class ExtPrettyPrint {
 
         try {
             sb.append(pp.indent(mIndentSize) + mResource.getString(PrettyPrintResources.TOKEN_IDENTIFIER));
-            sb.append(mResource.getString(PrettyPrintResources.TOKEN_AKI) + "- " + mExt.getExtensionId().toString()
-                    + "\n");
+            sb.append(mResource.getString(PrettyPrintResources.TOKEN_AKI)
+                    + "- " + mExt.getExtensionId().toString() + "\n");
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(PrettyPrintResources.TOKEN_CRITICAL));
             if (mExt.isCritical()) {
                 sb.append(mResource.getString(PrettyPrintResources.TOKEN_YES) + "\n");
@@ -973,12 +973,12 @@ public class ExtPrettyPrint {
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(PrettyPrintResources.TOKEN_CRITICAL));
             CertificateScopeOfUseExtension ext = (CertificateScopeOfUseExtension) mExt;
 
-            if (((Extension) mExt).isCritical()) {
+            if (mExt.isCritical()) {
                 sb.append(mResource.getString(PrettyPrintResources.TOKEN_YES) + "\n");
             } else {
                 sb.append(mResource.getString(PrettyPrintResources.TOKEN_NO) + "\n");
             }
-            Vector entries = ext.getCertificateScopeEntries();
+            Vector<CertificateScopeEntry> entries = ext.getCertificateScopeEntries();
 
             if (entries != null) {
                 sb.append(pp.indent(mIndentSize + 4) +
@@ -1474,7 +1474,7 @@ public class ExtPrettyPrint {
             }
 
             PolicyMappingsExtension ext = (PolicyMappingsExtension) mExt;
-            Enumeration maps = ext.getMappings();
+            Enumeration<CertificatePolicyMap> maps = ext.getMappings();
 
             sb.append(pp.indent(mIndentSize + 4) +
                     mResource.getString(PrettyPrintResources.TOKEN_MAPPINGS));
@@ -1530,7 +1530,7 @@ public class ExtPrettyPrint {
 
             sb.append(pp.indent(mIndentSize + 4) +
                     mResource.getString(PrettyPrintResources.TOKEN_ATTRIBUTES));
-            Enumeration attrs = ext.getAttributesList();
+            Enumeration<Attribute> attrs = ext.getAttributesList();
 
             if (attrs == null || !attrs.hasMoreElements()) {
                 sb.append(
@@ -1550,7 +1550,7 @@ public class ExtPrettyPrint {
                     sb.append(pp.indent(mIndentSize + 12) +
                             mResource.getString(
                                     PrettyPrintResources.TOKEN_VALUES));
-                    Enumeration values = attr.getValues();
+                    Enumeration<String> values = attr.getValues();
 
                     if (values == null || !values.hasMoreElements()) {
                         sb.append(mResource.getString(
@@ -1593,15 +1593,16 @@ public class ExtPrettyPrint {
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(
                     PrettyPrintResources.TOKEN_CERT_POLICIES) + "\n");
             CertificatePoliciesExtension cp = (CertificatePoliciesExtension) mExt;
-            Vector cpv = (Vector) cp.get("infos");
-            Enumeration e = cpv.elements();
+            @SuppressWarnings("unchecked")
+            Vector<CertificatePolicyInfo> cpv = (Vector<CertificatePolicyInfo>) cp.get("infos");
+            Enumeration<CertificatePolicyInfo> e = cpv.elements();
 
             if (e != null) {
                 while (e.hasMoreElements()) {
-                    CertificatePolicyInfo cpi = (CertificatePolicyInfo) e.nextElement();
+                    CertificatePolicyInfo cpi = e.nextElement();
 
-                    sb.append(pp.indent(mIndentSize + 8) + "Policy Identifier: "
-                            + cpi.getPolicyIdentifier().getIdentifier().toString() + "\n");
+                    sb.append(pp.indent(mIndentSize + 8)
+                            + "Policy Identifier: " + cpi.getPolicyIdentifier().getIdentifier().toString() + "\n");
                     PolicyQualifiers cpq = cpi.getPolicyQualifiers();
                     if (cpq != null) {
                         for (int i = 0; i < cpq.size(); i++) {
@@ -1611,8 +1612,8 @@ public class ExtPrettyPrint {
                                 sb.append(pp.indent(mIndentSize + 12)
                                         + "Policy Qualifier Identifier: CPS Pointer Qualifier - "
                                         + pq.getId() + "\n");
-                                sb.append(pp.indent(mIndentSize + 12) + "Policy Qualifier Data: "
-                                        + ((CPSuri) q).getURI() + "\n");
+                                sb.append(pp.indent(mIndentSize + 12)
+                                        + "Policy Qualifier Data: " + ((CPSuri) q).getURI() + "\n");
                             } else if (q instanceof UserNotice) {
                                 sb.append(pp.indent(mIndentSize + 12)
                                         + "Policy Qualifier Identifier: CPS User Notice Qualifier - "
@@ -1621,8 +1622,8 @@ public class ExtPrettyPrint {
                                 DisplayText dt = ((UserNotice) q).getDisplayText();
                                 sb.append(pp.indent(mIndentSize + 12) + "Policy Qualifier Data: \n");
                                 if (nref != null) {
-                                    sb.append(pp.indent(mIndentSize + 16) + "Organization: "
-                                            + nref.getOrganization().toString() + "\n");
+                                    sb.append(pp.indent(mIndentSize + 16)
+                                            + "Organization: " + nref.getOrganization().toString() + "\n");
                                     sb.append(pp.indent(mIndentSize + 16) + "Notice Numbers: ");
                                     int[] nums = nref.getNumbers();
                                     for (int k = 0; k < nums.length; k++) {
diff --git a/pki/base/util/src/netscape/security/x509/ACertAttrSet.java b/pki/base/util/src/netscape/security/x509/ACertAttrSet.java
index 57d9445c3a594aa8a264cb13157e25abaace6ea5..8a757d7f5c849ab871dbdf42951e16e51e0721f1 100755
--- a/pki/base/util/src/netscape/security/x509/ACertAttrSet.java
+++ b/pki/base/util/src/netscape/security/x509/ACertAttrSet.java
@@ -126,7 +126,7 @@ public class ACertAttrSet implements CertAttrSet {
      * 
      * @return an enumeration of the attribute names.
      */
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         return null;
     }
 
diff --git a/pki/base/util/src/netscape/security/x509/AlgorithmId.java b/pki/base/util/src/netscape/security/x509/AlgorithmId.java
index a30d45ca04cfede286fb4ca33f4fc0c35ee56c2a..b0113af4162406585133ada08849879309184107 100644
--- a/pki/base/util/src/netscape/security/x509/AlgorithmId.java
+++ b/pki/base/util/src/netscape/security/x509/AlgorithmId.java
@@ -760,7 +760,8 @@ public class AlgorithmId implements Serializable, DerEncoder {
      * All supported signing algorithms.
      */
     public static final String[] ALL_SIGNING_ALGORITHMS = new String[]
-    { "SHA1withRSA", "MD5withRSA", "MD2withRSA", "SHA1withDSA", "SHA256withRSA", "SHA512withRSA", "SHA1withEC",
+    {
+            "SHA1withRSA", "MD5withRSA", "MD2withRSA", "SHA1withDSA", "SHA256withRSA", "SHA512withRSA", "SHA1withEC",
             "SHA256withEC", "SHA384withEC", "SHA512withEC" };
 
 }
diff --git a/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java b/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
index b7f84f9f7c57fd12de41f1695bd5833d5c5f3a25..91b6c2598d90e137534940557552239753f3dcf4 100644
--- a/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
+++ b/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
@@ -322,7 +322,7 @@ public class AuthorityKeyIdentifierExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(KEY_ID);
         elements.addElement(AUTH_NAME);
